package de.intevation.flys.artifacts.model;

import de.intevation.flys.artifacts.math.Function;
import de.intevation.flys.artifacts.math.Identity;
import de.intevation.flys.artifacts.math.LinearFilterFunction;

public class WWAxisTypes
{
    protected boolean inCm1;
    protected boolean inCm2;

    public WWAxisTypes() {
        inCm1 = inCm2 = true;
    }

    public WWAxisTypes(WW ww) {
        this();
        classify(ww);
    }

    public void classify(WW ww) {
        if (!ww.startAtGauge()) inCm1 = false;
        if (!ww.endAtGauge())   inCm2 = false;
    }

    public boolean getInCm1() {
        return inCm1;
    }

    public void setInCm1(boolean inCm1) {
        this.inCm1 = inCm1;
    }

    public boolean getInCm2() {
        return inCm2;
    }

    public void setInCm2(boolean inCm2) {
        this.inCm2 = inCm2;
    }

    public WW.ApplyFunctionIterator transform(WW ww) {
        return transform(ww, false);
    }

    public WW.ApplyFunctionIterator transform(WW ww, boolean normalized) {
        // TODO: Do normalising.

        Function function1 = inCm1
            ? new LinearFilterFunction(100d, -ww.getStartDatum())
            : Identity.IDENTITY;

        Function function2 = inCm2
            ? new LinearFilterFunction(100d, -ww.getEndDatum())
            : Identity.IDENTITY;

        return new WW.ApplyFunctionIterator(ww, function1, function2);
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf-8 :
